/* ----------------------------------------------------------------------------
 * Copyright (c) 2015 Semiconductor Components Industries, LLC (d/b/a
 * ON Semiconductor), All Rights Reserved
 *
 * This code is the property of ON Semiconductor and may not be redistributed
 * in any form without prior written permission from ON Semiconductor.
 * The terms of use and warranty for this code are covered by contractual
 * agreements between ON Semiconductor and the licensee.
 * ----------------------------------------------------------------------------
 * g722_codec.h
 * - G722 codec support
 * ----------------------------------------------------------------------------
 * $Revision: 1.2 $
 * $Date: 2017/01/18 22:26:47 $
 * ------------------------------------------------------------------------- */
 
#ifndef G722_CODEC_H_INCLUDED
#define G722_CODEC_H_INCLUDED

#include "g722.h"
#include "ugstdemo.h"
#include "g722_com.h"

#include "g722.h"
#include <string.h>

typedef struct {
    short mode;
    g722_state * encoder;
    short BlkSize;
    short FrameSize;
    short * incode;
    unsigned char * code;
    short * pack;
    int Packet_in_Buffer_cntr;
    unsigned int Packet_in_flag;
    int debug;
} G722Enc;

typedef struct {
    short mode;
    g722_state * decoder;
    short BlkSize;
    short FrameSize;
    unsigned char * code;
    short * outcode;
    short * pack;
    int Packet_in_Buffer_cntr;    
    int Packet_in_flag;
    int debug;
} G722Dec;

extern void encoder_init(G722Enc g722_enc);
extern int encoderFunc(G722Enc g722_enc);

extern void decoder_init(G722Dec g722_dec);
extern int decoderFunc(G722Dec g722_dec);

extern void unpack_60byte_160byte(short * x, short * y);
extern void pack_160byte_60byte(short * x, short * y);

extern void unpack_64kbps(short * x, unsigned char * y, int loop);
extern void pack_64kbps(unsigned char * x, short * y, int loop);

extern G722Enc g722Encoder;
extern G722Dec g722_dec;


#endif /* G722_CODEC_H_INCLUDED */