/* ----------------------------------------------------------------------------
 * Copyright (c) 2016-2017 Semiconductor Components Industries, LLC (d/b/a ON
 * Semiconductor), All Rights Reserved
 *
 * This code is the property of ON Semiconductor and may not be redistributed
 * in any form without prior written permission from ON Semiconductor.
 * The terms of use and warranty for this code are covered by contractual
 * agreements between ON Semiconductor and the licensee.
 *
 * This is Reusable Code.
 *
 * ----------------------------------------------------------------------------
 * rsl10_lpdsp32_hw.h
 * - LPDSP32 accessible hardware registers and bit-field definitions
 * ----------------------------------------------------------------------------
 * $Revision: 1.5 $
 * $Date: 2017/05/25 21:02:51 $
 * ------------------------------------------------------------------------- */

#ifndef RSL10_LPDSP32_HW_H
#define RSL10_LPDSP32_HW_H

/* ----------------------------------------------------------------------------
 * If building with a C++ compiler, make all of the definitions in this header
 * have a C binding.
 * ------------------------------------------------------------------------- */
#if defined(__cplusplus)
extern "C"
  {
#endif

/* ----------------------------------------------------------------------------
 * Interrupt clear register
 * ------------------------------------------------------------------------- */
#define IRQ_CLR                         0xC00000
#define IRQ_CLR_ARM_6_CLR               (1<<14)
#define IRQ_CLR_ARM_5_CLR               (1<<13)
#define IRQ_CLR_ARM_4_CLR               (1<<12)
#define IRQ_CLR_ARM_3_CLR               (1<<11)
#define IRQ_CLR_ARM_2_CLR               (1<<10)
#define IRQ_CLR_ARM_1_CLR               (1<<9)
#define IRQ_CLR_ARM_0_CLR               (1<<8)
#define IRQ_CLR_DMA_7_CLR               (1<<7)
#define IRQ_CLR_DMA_6_CLR               (1<<6)
#define IRQ_CLR_DMA_5_CLR               (1<<5)
#define IRQ_CLR_DMA_4_CLR               (1<<4)
#define IRQ_CLR_DMA_3_CLR               (1<<3)
#define IRQ_CLR_DMA_2_CLR               (1<<2)
#define IRQ_CLR_DMA_1_CLR               (1<<1)
#define IRQ_CLR_DMA_0_CLR               (1<<0)

/* ----------------------------------------------------------------------------
 * ARM Cortex-M3 command register
 * ------------------------------------------------------------------------- */
#define ARM_CMD                         0xC00004
#define ARM_CMD_7                       (1<<7)
#define ARM_CMD_6                       (1<<6)
#define ARM_CMD_5                       (1<<5)
#define ARM_CMD_4                       (1<<4)
#define ARM_CMD_3                       (1<<3)
#define ARM_CMD_2                       (1<<2)
#define ARM_CMD_1                       (1<<1)
#define ARM_CMD_0                       (1<<0)

#if defined(__cplusplus)
  }
#endif
        
#endif /* RSL10_LPDSP32_HW_H */
